//+------------------------------------------------------------------+
//|                                              +OPTIONS_VOLUME.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#import "user32.dll"
   int GetWindowDC(int dc);
   int ReleaseDC(int h, int dc);
  bool GetWindowRect(int h, int& pos[4]);
#import
#import "gdi32.dll"
   int GetPixel(int dc, int x, int y);
#import
#import "wininet.dll"
int InternetAttemptConnect (int x);
  int InternetOpenA(string sAgent, int lAccessType, string sProxyName = "", string sProxyBypass = "", int lFlags = 0);
  int InternetOpenUrlA(int hInternetSession, string sUrl, string sHeaders = "", int lHeadersLength = 0,int lFlags = 0, int lContext = 0);
  int InternetReadFile(int hFile, int& sBuffer[], int lNumBytesToRead,int& lNumberOfBytesRead[]);
  int InternetCloseHandle(int hInet);
#import
extern  string               = "test";
extern  string              = "test";
extern  bool     _ = true;
extern  bool     _ = true;
extern  bool     __= false;
extern  int         _ = 14;
extern  string      _    = "Arial";
extern  int         _ = 7;
extern  int      __ = 0;
extern  color    _ = Coral;
extern  color    _      = CornflowerBlue;
color    _ ;
double in[15][3];
double hist[1000][61];
double prom[61];
double mno=1;
int Win_color;
int prewtime;
string inetpacth="http://xrust.land.ru//";
#property indicator_chart_window
//+------------------------------------------------------------------+
void init(){prewtime=0;IndicatorShortName("Open Interest indicatorXR  ");delgr();return;}
//+------------------------------------------------------------------+
void deinit(){delgr();return;}
//+------------------------------------------------------------------+
void start(){static int prewmno,bpch;
//----
   if(prewtime<TimeCurrent()-300){
   prewtime=TimeCurrent();
   readinet();
   ReadFile();
   }
   if(GetWndColor(Symbol())>0){_=Blue;color txcol=Black;}else{txcol=White;_=Green;}
   int b1=5,b2=6;
   if(bpch!=WindowBarsPerChart()){bpch=WindowBarsPerChart();}
   if(bpch>1000){b1=50;b2=150;}
   if(bpch>500&&bpch<1000){b1=23;b2=75;}
   if(bpch>200&&bpch<500){b1=13;b2=38;}
   if(bpch>100&&bpch<220){b1=8;b2=20;}
   if(bpch>50&&bpch<100){b1=5;b2=11;}
   if(bpch<50){b1=3;b2=6;}
   int barst=Time[__]+Period()*b1*60;
   int baren=Time[__]+Period()*b2*60;
   int dl=baren-barst;
   double razn=MathAbs(in[0][1]-in[1][1]);
   double sumbuy,sumsell;
   for(int i=0;i<15;i++){
     double prise=in[i][1];
     int sell= in[i][0];
     int buy = in[i][2];
     if(buy==0){buy=1;}
     if(sell==0){sell=1;}     
     sumbuy=sumbuy+buy;
     sumsell=sumsell+sell;
     double bs  = buy+sell;
     if(bs<1)bs=1;
     double kf  = dl/bs;
     int _sell=kf*sell;
     int _buy=kf*buy;
     if(__){
       if(_)SetText("sell",_,barst,prise,DoubleToStr(sell,0),_);
       if(sell>0)SetTLine(_,"sell",barst+_sell,prise,barst,prise," "+sell);
     }else{  
       if(_)SetText("sell",_+_,barst,prise,DoubleToStr(sell,0),_);
       SetRestangle(_,"sell",barst+_sell,prise,barst,prise-razn," "+sell);
     }  
     if(__){
       if(_)SetText("buy",_,baren,prise,DoubleToStr(buy,0),_);
       if(buy>0)SetTLine(_,"buy",baren,prise,baren-_buy,prise,buy);
     }else{  
       if(_)SetText("buy",_+_,baren,prise,DoubleToStr(buy,0),_);
       SetRestangle(_,"buy",baren,prise,baren-_buy,prise-razn,buy);
     }  
   }  
   string data="Total oi = "+DoubleToStr(sumbuy+sumsell,0)+" oi buy = "+DoubleToStr(sumbuy,0)+" oi sell = "+DoubleToStr(sumsell,0)+"  sell/buy = "+DoubleToStr(sumsell/sumbuy,2);
   string copyrite="Open Interest indicatorXR   ";
   SetLabel("Times new roman","cp",copyrite,txcol,1,1,1,9);
   SetLabel(_,"oi",data,txcol,1,12,1,_);
//----
return;}
//+------------------------------------------------------------------+
void readinet()
  {string nm=Symbol()+"_OI.csv";
   if(!IsDllsAllowed()){
     Alert("     DLL");
     return(0);
   }
   int rv = InternetAttemptConnect(0);
   if(rv != 0){
     Print("   InternetAttemptConnect()");
     return(0);
   }
   int hInternetSession = InternetOpenA("Microsoft Internet Explorer",0, "", "", 0);
   if(hInternetSession <= 0){
     Print("   InternetOpenA()");
     return(0);         
   }
   int hURL = InternetOpenUrlA(hInternetSession,inetpacth+nm, "", 0, 0, 0);
   if(hURL <= 0){
     Print("   InternetOpenUrlA()");
     InternetCloseHandle(hInternetSession);
     return;
   }      
   int cBuffer[256];
   ArrayInitialize(cBuffer,0);
   int dwBytesRead[1]; 
   ArrayInitialize(dwBytesRead,0);
   string TXT = "";
   while(!IsStopped()){
       bool bResult = InternetReadFile(hURL, cBuffer, 1024, dwBytesRead);
       if(dwBytesRead[0] == 0)break;
       string text = "";   
       for(int i = 0; i < 256; i++){
           text = text + CharToStr(cBuffer[i] & 0x000000FF);
        	  if(StringLen(text) == dwBytesRead[0])break;
        	  text = text + CharToStr(cBuffer[i] >> 8 & 0x000000FF);
        	  if(StringLen(text) == dwBytesRead[0])break;
           text = text + CharToStr(cBuffer[i] >> 16 & 0x000000FF);
           if(StringLen(text) == dwBytesRead[0])break;
           text = text + CharToStr(cBuffer[i] >> 24 & 0x000000FF);
         }
       TXT = TXT + text;
       Sleep(1);
     }
   if(TXT != ""){
       FileDelete(nm);   
       int h = FileOpen(nm, FILE_CSV|FILE_WRITE);
       if(h>0){
           FileWrite(h,TXT);
           FileClose(h);
         }else{Print("   FileOpen()");}
     }else{Print("  ");}
   InternetCloseHandle(hInternetSession);
   return;}
//+------------------------------------------------------------------+
int GetWndColor(string sy)
   { 
     int hWnd = WindowHandle(sy, Period());
     int hDC = GetWindowDC(hWnd);
     int rect[4];
     GetWindowRect(hWnd, rect);
     int wW = rect[2] - rect[0];         //  
     int wH = rect[3] - rect[1];         //  
     
     int col = GetPixel(hDC, 2, 2);
     if(col==-1)                         //     
     {
       col = GetPixel(hDC, wW-3, wH-3); 
       if(col==-1)                       //     
       col = GetPixel(hDC, 2, wH-3); 
       if(col==-1)                       //     
       col = GetPixel(hDC, wW-3, 2);     
       if(col==-1)                       //     
       {
         ReleaseDC(hWnd, hDC);
         return(Win_color);
       }
      }
     ReleaseDC(hWnd, hDC);
     return(col);
   }
//+------------------------------------------------------------------+
void SetLabel(string fn,string nm, string tx, color cl, int xd, int yd, int cr=0, int fs=9) {
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_LABEL, 0, 0,0);
  ObjectSetText(nm, tx,fs,fn, cl);
  ObjectSet(nm, OBJPROP_COLOR    , cl);
  ObjectSet(nm, OBJPROP_XDISTANCE, xd);
  ObjectSet(nm, OBJPROP_YDISTANCE, yd);
  ObjectSet(nm, OBJPROP_CORNER   , cr);
  ObjectSet(nm, OBJPROP_FONTSIZE , fs);
  ObjectSet(nm, OBJPROP_BACK , false);
}
//+------------------------------------------------------------------+ 
void delgr(){
   for(int i=ObjectsTotal();i>=0;i--){
     if("sumoi"==StringSubstr(ObjectName(i),0,5)){ObjectDelete(ObjectName(i));}
     if("opint"==StringSubstr(ObjectName(i),0,5)){ObjectDelete(ObjectName(i));}
   }
   ObjectDelete("oi");
   ObjectDelete("cp");
return;
}
//+------------------------------------------------------------------+   
void SetText(string op,color cl,int t1,double p1,string tx="",int razm=8){
  string nm="sumoi"+op+DoubleToStr(p1,Digits);
  if(ObjectFind(nm)<0)ObjectCreate(nm, OBJ_TEXT, 0, 0,0, 0,0);
  ObjectSet(nm, OBJPROP_TIME1 , t1);
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSetText(nm,tx,razm,_,cl);
  ObjectSet(nm, OBJPROP_BACK , _);
return;
}   
//+------------------------------------------------------------------+
void SetTLine(color cl, string nm="",
              datetime t1=0, double p1=0, datetime t2=0, double p2=0,string vol="") {
  nm="opint "+nm+p1;
  if(ObjectFind(nm)<0)ObjectCreate(nm, OBJ_TREND, 0, 0,0, 0,0);
  ObjectSet(nm, OBJPROP_TIME1 , t1);
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSet(nm, OBJPROP_TIME2 , t2);
  ObjectSet(nm, OBJPROP_PRICE2, p2);
  ObjectSet(nm, OBJPROP_COLOR , cl);
  ObjectSet(nm, OBJPROP_RAY   , false);
  ObjectSet(nm, OBJPROP_STYLE , 0);
  ObjectSet(nm, OBJPROP_WIDTH , _);
  ObjectSetText(nm,vol,3,"Arial",White);
  ObjectSet(nm, OBJPROP_BACK , _);
}
//+------------------------------------------------------------------+
void SetRestangle(color cl, string nm="",datetime t1=0, double p1=0, 
                  datetime t2=0, double p2=0,string vol=""){
  nm="opint "+nm+p1;
  if(ObjectFind(nm)<0)ObjectCreate(nm, OBJ_RECTANGLE, 0, 0,0, 0,0);
  ObjectSet(nm, OBJPROP_TIME1 , t2);
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSet(nm, OBJPROP_TIME2 , t1);
  ObjectSet(nm, OBJPROP_PRICE2, p2);
  ObjectSet(nm, OBJPROP_COLOR , cl);
  ObjectSet(nm, OBJPROP_RAY   , false);
  ObjectSet(nm, OBJPROP_STYLE , 0);
  ObjectSet(nm, OBJPROP_WIDTH , _);
  ObjectSetText(nm,vol,3,"Arial",White);
  ObjectSet(nm, OBJPROP_BACK , _);
}     
//+------------------------------------------------------------------+  
bool ReadFile(){int i,x,y;int hd;
   string fn=Symbol()+"_OI.csv";
   double spr=MarketInfo(Symbol(),MODE_SPREAD)*Point;  
   hd=FileOpen(fn,FILE_CSV|FILE_READ); 
   if(hd<0){
     Print(GetLastError(),"  ",fn,"  File not found",hd);   
     return(false);
   }else{
   for(i=0;i<50;i++){
     string out=FileReadString(hd);
     for(x=0;x<4;x++){
     int pos=StringFind(out,",",0);
     in[i][x]=StrToDouble(StringSubstr(out,0,pos+1));
     out=StringSubstr(out,pos+1,0);
     }
     if(FileIsEnding(hd)){break;}
   }  
   ArrayResize(in,i);
   FileClose(hd);
   return(true);
   }
   return(true);
}

